<template>
  <input type="hidden" :name="inputName" :value="JSON.stringify(tabs)">
<!--<div class="flex m-3 justify-content-end flex-wrap align-content-center"> -->
  <div class="flex justify-content-end flex-wrap align-content-center m-3">
                    <span class="p-input-icon-left">
                        <i class="pi pi-search m-1"/>
                        <InputText v-model="filters['global'].value" placeholder="Keyword Search" style="width:15rem ;" />
                        <Button type="button"  label="Limpiar" @click="clearFilter" class="mt-3"/>
                    </span>
              
                
  </div>

  <div class="flex justify-content-end flex-wrap align-content-center m-3 gap-1">
    <Button icon="pi pi-plus" label="Tab" @click="addTab" />
  </div>
  
<!--</div>--> 

  <TabView v-model:activeIndex="currentTabIndex" @update:activeIndex="changeTab" :scrollable="true" name="mistabs">
    

    <TabPanel v-for="(tab, index) in tabs" :key="tab.title" :header="tab.title">
      <div>
        <div class="flex justify-content-between ">
          <div class="flex align-items-center">
            <h3 class="m-0">{{ tab.title }}</h3>
          </div>
          <div>
            <Button icon="pi pi-sync" class="p-button-rounded p-button-secondary mr-2" @click="RefreshPage" />
            <Button icon="pi pi-pencil" class="p-button-rounded p-button-secondary mr-2" @click="editTab" />
            <Button icon="pi pi-trash" class="p-button-warning p-button-rounded" @click="tabDeleteDialog = true" />
          </div>
        </div>

        <DataTable v-model:filters="filters" :reorderableColumns="true" :value="tab.pages" class="mt-3" @rowReorder="onRowReorder" filterDisplay="row" :loading="loading"
                :globalFilterFields="['status','title']">
          <template #header>


            

            <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
              <h4 class="m-0">Administrar Páginas</h4>
                <div>
                <Button icon="pi pi-plus" label="Página" @click="addPage" /><!--@click="addPage"-->
              </div>
            </div>
            <diV>
  
            </diV>
          </template>
<!--landings filter
<div v-if="getFechas2(slotProps)">-->
  

          <Column rowReorder headerStyle="width: 3rem" :reorderableColumn="false" />
          <!--<Column field="id" header="Página" :reorderableColumn="false"></Column>-->
          <Column field="title" header="Título" :reorderableColumn="false"></Column>
          <!--<Column field="image" header="Imagen" :reorderableColumn="false">  
          </Column>-->
          <Column header="Imagen">
            <template #body="slotProps">
              <div>
              <img :src="`${slotProps.data.image}`" :alt="slotProps.data.image" class="w-6rem shadow-2 border-round"
                style="width: 24px" /> 
              </div>
            </template>
          </Column>

          <!--<Column field="description" header="Descripción" :reorderableColumn="false"></Column>-->
        <Column header="Fechas" :reorderableColumn="false">
            <template #body="slotProps">
             <!-- {{slotProps.data.dates[0]}}-->
             <div v-if="getFechas2(slotProps,index)==1">{{ slotProps.data.dates[0] }} </div>
              <div v-if="getFechas2(slotProps,index)==2">{{ "" }} </div>                
              <div v-if="getFechas2(slotProps,index)==3">{{ "Fecha expirada" }} </div>
              <div v-if="getFechas2(slotProps,index)==4">{{ slotProps.data.dates[0] }} </div>
             
            </template>
          </Column>
        
          <!--<Column field="status" header="Status" :reorderableColumn="false"  style="min-width: 12rem">
          <template #body="slotProps">
              <div v-if="getFechas2(slotProps,index)!=3">{{ getStatus(status[0]) }} </div>
              <div v-if="getFechas2(slotProps,index)==3">{{ getStatus(status[1]) }} </div>                
            </template>
          
        </Column>-->
             <!--
               <template #filter="{ filterModel, filterCallback }">
                  
                    <Dropdown v-model="filterModel.value" @change="filterCallback()" :options="statuses" placeholder="Select One" class="p-column-filter" style="min-width: 3rem;color: black; align-content: center;" :showClear="true">
                    </Dropdown>
                 
                </template>
              -->

    <!--      </Column>-->

          <Column header="Opciones" :reorderableColumn="false">
            <template #body="slotProps">
              
              <Button icon="pi pi-pencil" class="p-button-rounded p-button-secondary mr-2" @click="editPage(slotProps)" />
              <Button icon="pi pi-trash" class="p-button-warning p-button-rounded" @click="selectPage(slotProps)" />
              
            </template>
          </Column>
        <!--</div> div para ocultar landing caducas-->
        </DataTable>
      
  

      </div>
    </TabPanel>

   
  </TabView>
  <!--colores-->
  <div>


  </div>

  <!--fin colores-->

  <Dialog v-model:visible="tabDialog" :style="{ width: '450px' }" header="Configuración Tab" :modal="true"
    class="p-fluid">
    <div class="flex flex-column gap-2">
      <label for="username">Título</label>
      <InputText id="username" v-model="currentTab.title" /><!--currentTab.title-->
      <small v-if="false" id="username-help">Enter your username to reset your password.</small>
    </div>
    <div class="flex flex-column gap-2 mt-3">
      <label for="description">Descripción</label>
      <Textarea id="description" v-model="currentTab.description" required="true" rows="3" cols="20" />
    </div>
    <template #footer>
      <Button label="Cancelar" icon="pi pi-times" class="p-button-text" @click="hideAddTab" />
      <Button v-if="!isEditingTab" label="Guardar" icon="pi pi-check" class="p-button-text" @click="saveTab" />
      <Button v-if="isEditingTab" label="Actualizar" icon="pi pi-check" class="p-button-text" @click="updateTab" />
    </template>
  </Dialog>
  <!--mi dialogo de espera -->
  <Dialog v-model:visible="waitDialod" :style="{ width: '450px' }" header="Cargando datos" :modal="true" class="p-fluid">
    <div class="loading-page" id="loading-page">
      <div id="counter" class="counter">
        <p class="flex flex-column gap-2 ">Cargando Datos</p>
        <h1 class="flex flex-column gap-2 " id="conta">0</h1>

        <hr style="width: 100%;" id="barraload">
      </div>
    </div>
    <template #footer>
    </template>
  </Dialog>

  <!--fin mi dialogo de espera-->
  <Dialog v-model:visible="pageDialog" :style="{ width: '500px' }" header="Configuración Página" :modal="true"
    class="p-fluid">
    <div class="flex flex-column gap-2 ">
      <!--iniciando autocompletar-->
      <div class="autocomplete">
        <!--  <label for="pagina">Página</label>-->

      </div>
    </div>

    <div class="flex flex-wrap gap-3">
      <div class="flex align-items-center">
        <RadioButton v-model="opcionLanding" inputId="opinterna" name="landing" value="Interna"
          @change="getCahngedoption" />
        <label for="opinterna" class="ml-2">Interna</label>
      </div>
      <div class="flex align-items-center">
        <RadioButton v-model="opcionLanding" inputId="opexterna" name="landing" value="Externa"
          @change="getCahngedoption" />
        <label for="opexterna" class="ml-2">Externa</label>
      </div>

    </div>
    <div class="flex flex-column gap-2 mt-3" v-if="isEditingLiking">
      <label for="enlace">Enlace</label>
      <InputText id="Enlace" v-model="enlace" /><!--name="Enlace"-->
    </div>


    <!--fin del autocomplet-->

    <div class="flex flex-column gap-2 mt-3" v-if="!isEditingLiking">
      <label for="sss">Seleccionar landing</label>
      <AutoComplete v-model="value" :suggestions="items" @complete="search" optionLabel="post_title" forceSelection
        @item-select="getItemSelected" placeholder="Buscar landing" />

    </div>

    <div class="flex flex-column gap-2 mt-3">
      <label for="pageTitle">Título</label>
      <InputText id="pageTitle" v-model="currentPage.title" />
    </div>

    <div class="flex flex-column gap-2 mt-3">
      <label for="image">Imágen</label>
      <div class="flex flex-column mt-1">
        <div class="flex justify-content-start flex-wrap align-content-center mb-3" :style="{ width: '100%' }">

          <InputText id="image" v-model="currentPage.image" :style="{ width: '90%' }" />

          <Button icon="pi pi-plus" label="" @click="selectImage" />
        </div>
      </div>
      <div v-html="showImagenLink.html_code" class="flex flex-column gap-2 mt-1" aling="center">



      </div>

    </div>
    <div class="flex flex-column gap-2 mt-2">
      <label for="pageDescription" class="mt-2">Descripción</label>
      <Textarea id="pageDescription" v-model="currentPage.description" required="true" rows="3" cols="20" width="100%" />
    </div>

        
        <div class="flex flex-column mt-4 gap-4">
        <div class="flex gap-2">
          <Checkbox v-model="checked" :binary="true" inputId="fechexpiracion" name="fechexpiracion" value="yes"  @change="filterfecha"/>
        <label for="fechexpiracion" class="gap-2">Activar expiración </label>
        </div>
        </div>
    

    <div v-if="!isFechaExpiracion" class="flex justify-content-start flex-wrap align-content-center mb-3 mt-3 gap-2" :style="{ width: '100%' }">
      <label for="fechas" class="gap-2">Selecciona un rango de fechas</label>
      <Calendar v-model="dates" dateFormat="dd/mm/yy" selectionMode="range" @date-select="saveDates" showIcon class="mt-2"
        inputId="fechas" :style="{ width: '90%' }" name="fechas"/>
      <!--<Button icon="pi-calendar-plus" label="" @click="saveDates"/>-->
    </div>

    <template #footer>
      <Button label="Cancelar" icon="pi pi-times" class="p-button-text" @click="pageDialog = false" />
      <Button v-if="!isEditingPage" label="Guardar" icon="pi pi-check" class="p-button-text" @click="savePageX" />
      <Button v-if="isEditingPage" label="Aplicar" icon="pi pi-check" class="p-button-text" @click="updatePageX" />
    </template>
  </Dialog>

  <Dialog v-model:visible="imagenDialog" :style="{ width: '450px' }" header="Seleccionar Imagen" :modal="true"
    class="p-fluid" ref="ImagenDialog" id="cargarImagenApp">
    <div class="flex flex-column gap-2">
      <Button icon="pi pi-plus" label="Seleccionar imagen" @click="openMediaselector" />
    </div>


    <!--visualizar la imagen  preview-->
    <div class="flex flex-column gap-2 mt-3">
      <div v-html="currentImagen.html_code" class="flex flex-column gap-2 mt-3" aling="center">

      </div>

    </div>

    <div class="flex flex-column gap-2 mt-3">
      <label for="imageTitle">Título</label>
      <InputText id="imageTitle" v-model="currentImagen.title" />
    </div>

    <div class="flex flex-column gap-2">
      <label for="imagen-url">Url</label>
      <InputText id="imagen-url" v-model="currentImagen.link" />
    </div>


    <div class="flex flex-column gap-2 mt-3">
      <label for="imageDescription">Descripción</label>
      <Textarea id="imageeDescription" v-model="currentImagen.description" required="true" rows="3" cols="20" />
    </div>

    <template #footer>
      <Button label="Cancelar" icon="pi pi-times" class="p-button-text" @click="imagenDialog = false" />
      <Button v-if="!isEditingImagen" label="Guardar" icon="pi pi-check" class="p-button-text" @click="saveImagen" />
    </template>
  </Dialog>


  <Dialog v-model:visible="tabDeleteDialog" :style="{ width: '450px' }" header="Confirmar" :modal="true">
    <div class="flex align-items-center justify-content-center">
      <i class="pi pi-exclamation-triangle mr-3" style="font-size: 2rem" />
      <span v-if="currentTabIndex != -1">¿Esta seguro de querer eliminar el tab <b>"{{ currentTab.title }}"</b>?</span>
    </div>
    <template #footer>
      <Button label="No" icon="pi pi-times" class="p-button-text" @click="tabDeleteDialog = false" />
      <Button label="Si" icon="pi pi-check" class="p-button-text" @click="deleteTab" />
    </template>
  </Dialog>

  <Dialog v-model:visible="pageDeleteDialog" :style="{ width: '450px' }" header="Confirmar" :modal="true">
    <div class="flex align-items-center justify-content-center">
      <i class="pi pi-exclamation-triangle mr-3" style="font-size: 2rem" />
      <span v-if="currentTabIndex != -1">¿Esta seguro de querer eliminar la página <b>"{{ currentPage.title
      }}"</b>?</span>
    </div>
    <template #footer>
      <Button label="No" icon="pi pi-times" class="p-button-text" @click="pageDeleteDialog = false" />
      <Button label="Si" icon="pi pi-check" class="p-button-text" @click="deletePageX" />
    </template>
  </Dialog>
</template>

<script setup>
import { createConditionalExpression } from '@vue/compiler-core';
import { VueElement, reactive, ref } from 'vue';
import { FilterMatchMode } from 'primevue/api';
class Page {
  constructor() {
    this.id = "";
    this.title = "";
    this.page = {};
    this.description = "";
    this.link = "";
    this.image = "";
    this.html_code = ""
    this.dates = [];
    this.status="";
  }
}

class Imagen {
  constructor() {
    this.title = "";
    this.description = "";
    this.link = "";
    this.html_code = "";
  }

}



class Tab {
  constructor(title) {
    this.title = title;
    this.description = "";
    this.pages = [];
  }
}

const myListItem = ref({});
const tabs = ref([new Tab("Tab 1")]);
const inputName = ref('');
const tabDialog = ref(false);
const isEditingTab = ref(false);
const isEditingPage = ref(true);
const isEditingLiking = ref(false);
const isEditinWaitDialod = ref(false);
const pageDialog = ref(false);
const imagenDialog = ref(false);
const waitDialod = ref(false);
const isEditingImagen = ref(false);
const tabDeleteDialog = ref(false);
const pageDeleteDialog = ref(false);
const showImagenLink = reactive(['html_code:0']);
const imagestatus = ref(false);
var myCurrentData = [];
var attachmentoader;
var mediaUploader;
var urlumagen;
const activeIndex=ref(0);
const currentTabIndex = ref(0);
const currentTab = ref({});
currentTab.value = tabs.value[0];

const mychangeTab = (index) => {
  currentTab.value = { ...tabs.value[index] };
  currentTabIndex.value = index;
  activeIndex.value=index;
};



try {
  inputName.value = window.acf_home_dynamic.name;
  tabs.value = JSON.parse(window.acf_home_dynamic.value.replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r"));//.replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r")

} catch (error) {
  console.log(error);
}

//modales
//const currentTab = ref({});
//const currentTabIndex = ref(0);

const currentPage = ref({});
const currentPageIndex = ref(0);

const currentImagen = ref({});
const currentImagenIndex = ref(0);
const currentItemsData = ref({});
//valores actuales
//currentTab.value = tabs.value[0];

const mylandingpages = [];

//const activeIndex=ref(0);

const value = ref("");
const items = ref([]);
const dates = ref();
const opcionLanding = ref('Interna');
const enlace=ref('');
const status=ref(['activo', 'caduco']);
const statuses=ref(['activo', 'caduco']);
var mytabindex=9;
var indiceElemento=-2;
var fechas1=ref("");
const checked = ref(true);
const isFechaExpiracion = ref(false);
const getFechas2=(slotProps,index)=>{
    let misfechas=slotProps.data.dates[0].split('-');
    let datehoy = new Date();
    let day = datehoy.getDate();
    let month = datehoy.getMonth() + 1;
    let year = datehoy.getFullYear();
    let xcurrentDate = `${day}/${month}/${year}`;
    let misfechas1=misfechas[0].split("/");
    let misfechas2=misfechas[1].split("/");
    
    var f1=new Date(misfechas1[2],misfechas1[1]-1,misfechas1[0]);
    var f2=new Date(misfechas2[2],misfechas2[1]-1,misfechas2[0]);
    var f3=new Date(datehoy.getFullYear(),datehoy.getMonth(),datehoy.getDate());
    if((f3>=f1) && (f3<=f2)){

      return 1;    
    }else { 
       if(misfechas2[2]=='0000' && misfechas2[1]=='00'){
        return 2;
       } else{
              if(f3>f2 && f3>f1){
              //currentTabIndex.value=index;
              //currentPageIndex.value=slotProps.index;
              return 3;  
            }else{
              if(f3<=f1 && f3<=f2){
              return 4;
            }
            }
          }
}
}

/*Activo page*/
const getFechasActivePages=(rangofechas)=>{
    //console.log("mis fechas "+ rangofechas);
    let misfechas=rangofechas.split('-');
    let datehoy = new Date();
    let day = datehoy.getDate();
    let month = datehoy.getMonth() + 1;
    let year = datehoy.getFullYear();
    let xcurrentDate = `${day}/${month}/${year}`;
    let misfechas1=misfechas[0].split("/");
    let misfechas2=misfechas[1].split("/");

    var f1=new Date(misfechas1[2],misfechas1[1]-1,misfechas1[0]);
    var f2=new Date(misfechas2[2],misfechas2[1]-1,misfechas2[0]);
    var f3=new Date(datehoy.getFullYear(),datehoy.getMonth(),datehoy.getDate());
    if((f3>=f1) && (f3<=f2)){
      return true;    
    }else { 
      if(misfechas2[2]=='0000' && misfechas2[1]=='00'){
        return true;
      }else{ 
        if(f3>f2 && f3>f1){
          return false;  
        }else{
              if(f3<f1 && f3<f2){
              return true;
            }}

        
      }
      
}
}
const clearFilter = () => {
      
       filters.value.global.value=null;
       filters.value.status.value=null;
       filters.value.title.value=null;
};
/*active page*/
//clearFilter();

const getStatus = (status) => {
    switch (status) {
        case 'activo':
            return 'activo';

        case 'caduco':
            return 'caduco';

    }
}
//const loading = ref(false);
const filters = ref({
    global: { value: 'activo', matchMode: FilterMatchMode.CONTAINS },
    status: { value: null, matchMode: FilterMatchMode.EQUALS },
    title: { value: null, matchMode: FilterMatchMode.CONTAINS }
});

const getCahngedoption=(event)=>{
 if(opcionLanding.value=="Externa"){
  //console.log(opcionLanding.value);
  isEditingLiking.value=true;
  //isEditingPage.value=false;
}else{
  isEditingLiking.value=false;
  //isEditingPage.value=false;
}

}

const filterfecha=()=>{
  if(checked.value==true){
       //console.log("seleccionado");
       isFechaExpiracion.value=false;
  }else{
    
    //console.log("no sleccionado");
    dates.value="";
    fechas1.value="";
    isFechaExpiracion.value=true;
  
  }

}
//const months = ["January","February","March","April","May","June","July","August","September","October","November","December"];
const saveDates = (event) => {
  fechas1.value=fechas.value;

}
const getItemSelected = (event) => {
  currentPage.value.title = event.value.post_title;
  //currentPage.value.link = event.value.guid;
  currentPage.value.id = event.value.ID;
  
  var sPath = window.location.pathname;
  var sPage =sPath.substring(0, (sPath.lastIndexOf('/')-'wp-admin'.length));

  currentPage.value.link=""+ window.location.origin + sPage + event.value.post_name;

}

const search = (event) => {
  fetch(window.wpApiSettings.root + 'go1mx/v1/landings?query=' + event.query)
    .then(response => response.json())
    .then((response) => {
      items.value = response;
    });
}
const updateJson=(qoptipo)=>{
  var URLsearch = window.location.search; 
  URLsearch=URLsearch.replace("?","");
  var indi=URLsearch.indexOf("&");
  URLsearch=URLsearch.substring(indi,0);
  indi=URLsearch.indexOf("=");
  URLsearch=URLsearch.substring(indi+1);
 return new Promise((resolve,reject)=>{
  fetch(window.wpApiSettings.root + 'go1mx/v1/update_metalandings', {
    method: 'POST',
    headers: {
        "Content-Type": "application/json;charset=iso-8859-1",
    },

    body:JSON.stringify({post_id:URLsearch,data:tabs.value,qtipo:qoptipo})

}).then((res) => resolve(res.json()))
  .catch((err) => reject(res));

});
  
  
}

const addTab = () => {
  currentTab.value = new Tab("Tab " + (tabs.value.length + 1));
  tabDialog.value = true;
  isEditingTab.value = false;
};

const addImg = () => {

  currentImagen.value = new Imagen();
  imagenDialog.value = true;
  isEditingImagen.value = true;

};

const buscarLandings = (event) => {
  console.log(event);
};

const openMediaselector = () => {
  if (imagestatus.value == false) {
    meduaUpLoaderOPen();

  } else {
    showUrl();
  }

}

const saveImagen = () => {
  tabs.value[currentTabIndex.value].Imagen.push({ ...currentImagen.value });
  imagenDialog.value = false;
};

const openWdialog = () => {
  waitDialod.value = true;
  CargarLanding();
  isEditinWaitDialod.value = true;
}


const addPage = () => {
  currentPage.value = new Page();
  showImagenLink.html_code = "";
  pageDialog.value = true;
  isEditingPage.value = false;
  dates.value = currentPage.value.dates[0];
  value.value = "";
  enlace.value="";
  //console.log('indice tab' + currentTabIndex.value);
  //mytabindex=currentTabIndex.value;
  if(parseInt(""+mytabindex)===9){
  mytabindex=currentTabIndex.value;
  }else{
    currentTabIndex.value=mytabindex;
  }

  //updateJson('0');
  //changeTab(mytabindex);

};


const hideAddTab = () => {
  tabDialog.value = false;
};

const editTab = () => {
  currentTab.value = { ...tabs.value[currentTabIndex.value] };
  tabDialog.value = true;
  isEditingTab.value = true;
};

const editPage = (props) => {
 
  if(parseInt(""+mytabindex)===9){
  mytabindex=currentTabIndex.value;
  }else{
    currentTabIndex.value=mytabindex;
  }
  currentPageIndex.value = props.index;
  currentPage.value = { ...props.data };
  indiceElemento = tabs.value[mytabindex].pages.findIndex(el => el.html_code == currentPage.value.html_code);
  showImagenLink.html_code="<img src='" + currentPage.value.image  +
"' class='img-thumbnails' width='100' style='display: block; margin-left: auto; margin-right: auto;  width: 25%;'>";
  
  let fechas33=currentPage.value.dates[0].split("-");  
  //console.log(fechas33[1]);
  if(fechas33[1]==" 00/00/0000"){
         dates.value="";
         fechas1.value="";
         //fechas.value="";
  }
  else {
    dates.value = currentPage.value.dates[0];
    //checked.value="yes";
  }
  if (currentPage.value.id == -1) {

    opcionLanding.value = 'Externa';
    enlace.value = currentPage.value.link;
    isEditingLiking.value = true;
  } else {
    opcionLanding.value = 'Interna';
    value.value=currentPage.value.title;
    isEditingLiking.value = false;

  }
    isEditingPage.value = true;
    pageDialog.value = true;
    //activeIndex.value=gindex;
    //changeTab(gindex);
    //updateJson('0');
};

const saveTab = () => {
  tabs.value.push({ ...currentTab.value });
  tabDialog.value = false;
  currentTabIndex.value = tabs.value.length - 1;
};



const savePageX= () => {
updateJson('0').then(data=>{
  tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
  savePage();
})
}
//updatePageX
const updatePageX= () => {
updateJson('0').then(data=>{
  tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
  updatePage();
})
}
//deletePageX
const deletePageX= () => {
updateJson('0').then(data=>{
  tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
  deletePage();
})
}


const RefreshPage= () => {
updateJson('0').then(data=>{
  tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
})
}


const savePage = () => {

  if(opcionLanding.value=="Externa"){
  currentPage.value.link=Enlace.value;
  currentPage.value.title=pageTitle.value;
  currentPage.value.id="-1";
  //console.log(Enlace.value +" --- "+pageTitle.value);
   }
   if(isFechaExpiracion.value==false){
      fechas1.value=fechas.value;
   }

   if(fechas1.value.length>=15){
      currentPage.value.dates.push(fechas1.value);
      if(getFechasActivePages(fechas1.value)){
            currentPage.value.status="activo";
      }else{
        currentPage.value.status="caduco";
      }

  }else{
    let dateini = new Date().toLocaleDateString();
    let myArray = dateini.split("/");
    let dia = myArray[0];
    let mes = myArray[1];
    let ann = myArray[2];
    if (mes.length < 2) {
      mes = '0' + mes;
    }
    if (dia.length < 2) {
      dia = '0' + dia;
    }

    fechas1.value = "" + dia + "/" + mes + "/" + ann + " - 00/00/0000";
    currentPage.value.dates.push(fechas1.value);
    if(getFechasActivePages(fechas1.value)){
           //console.log('activo');
           currentPage.value.status="activo";
    }
  
  }
  
if(currentPage.value.link!=""){
  //JSON.parse(window.acf_home_dynamic.value.replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r"));
  let cleanfechas=currentPage.value.dates[0].replace(/\//g,"").replace(/ /g,"");
  currentPage.value.html_code=""+ mytabindex+"-"+currentPage.value.id+"-"+ cleanfechas.trim() +"-"+ currentPage.value.title;
  currentPage.value.description=currentPage.value.description.replace(/\n/g, "\\n").replace(/['"]+/g, '').replace(/["']/g, "´").replace(/(<a href="[\w\._\-:\/]+" target="_blank">|<\/a>)/gi, "");
  tabs.value[mytabindex].pages.push({ ...currentPage.value });
  pageDialog.value = false;
  isEditingPage.value = false;
  updateJson('1').then(data=>{
    tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
    changeTabIndexall(mytabindex);

  });

}
};

const updateTab = () => {
  tabs.value[currentTabIndex.value] = { ...currentTab.value };
  tabDialog.value = false;
};

const updatePage = () => {
  //console.log("aquidsds " + mytabindex);
  if (opcionLanding.value == "Externa") {
    currentPage.value.link = enlace.value;
    currentPage.value.title= pageTitle.value;
    currentPage.value.id="-1";
  }
  if(isFechaExpiracion.value==false){
      fechas1.value=fechas.value;
      //console.log("fffff " + fechas.value);
   }else{
        //if(isFechaExpiracion.value==true){
      fechas1.value="";
      dates.value="";
      //console.log("sin fechas");
        //}
    }
 if(fechas1.value.length>=15){
  //console.log(dates.value);
    currentPage.value.dates[0]=fechas1.value;  
    if(getFechasActivePages(fechas1.value)){
            currentPage.value.status="activo";
      }else{
        currentPage.value.status="caduco";
      }

   
  }
  else{
    let dateini = new Date().toLocaleDateString();
    let myArray = dateini.split("/");
    let dia = myArray[0];
    let mes = myArray[1];
    let ann = myArray[2];
    if (mes.length < 2) {
      mes = '0' + mes;
    }
    if (dia.length < 2) {
      dia = '0' + dia;
    }
    //console.log("update page " + fechas1.value);

    fechas1.value = "" + dia + "/" + mes + "/" + ann + " - 00/00/0000";
    currentPage.value.dates[0]=fechas1.value;
    //currentPage.value.dates.push(fechas1.value);
    if(getFechasActivePages(fechas1.value)){
           currentPage.value.status="activo";
    }

  }

  //console.log("valor  "+ tabs.value[currentTabIndex.value].pages[indiceElemento].title + " cambiar por" + currentPage.value.title);
  let cleanfechas=currentPage.value.dates[0].replace(/\//g,"").replace(/ /g,"");
  currentPage.value.html_code=""+ mytabindex+"-"+currentPage.value.id+"-"+ cleanfechas.trim() +"-"+ currentPage.value.title;  
  currentPage.value.description=currentPage.value.description.replace(/\n/g, '\\n').replace(/['"]+/g, '').replace(/["']/g, "´");

  tabs.value[mytabindex].pages[indiceElemento]= { ...currentPage.value };
  pageDialog.value = false;
  updateJson('1').then(data=>{

    tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
    changeTabIndexall(mytabindex);

  });

};

const changeTab = (index) => {
  currentTab.value = { ...tabs.value[index] };
  currentTabIndex.value = index;
  RefreshPage();
  mytabindex=index;
  changeTabIndexall(index);

  //console.log("tab "+ index);
};

const selectPage = (props) => {
  currentPageIndex.value = props.index;
  currentPage.value = { ...props.data };
  pageDeleteDialog.value = true;
};

const deleteTab = () => {
  tabs.value.splice(currentTabIndex.value, 1)
  tabDeleteDialog.value = false;
  currentTabIndex.value = tabs.value.length - 1;
};

const deletePage = () => {
  if(parseInt(""+mytabindex)===9){
  mytabindex=currentTabIndex.value;
  }else{
    currentTabIndex.value=mytabindex;
  }
  indiceElemento = tabs.value[mytabindex].pages.findIndex(el => el.html_code == currentPage.value.html_code);
  tabs.value[mytabindex].pages.splice(indiceElemento, 1);
  updateJson('1').then(data=>{

    tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
    changeTabIndexall(mytabindex);

  });
  pageDeleteDialog.value = false;
};

function changeTabIndexall(indicemm){
 
 (function(){
 let listaHeader=document.querySelectorAll('li.p-tabview-header');
 let lista=document.querySelectorAll('li.p-tabview-header a.p-tabview-nav-link');
 let listacontenido=document.querySelectorAll('div.p-tabview-panels div.p-tabview-panel');
 for(let itabs=0;itabs<lista.length;itabs++){
   listaHeader[itabs].classList.remove('p-highlight');    
   lista[itabs].setAttribute('aria-selected','false');
   listacontenido[itabs].setAttribute('style','display: none');//p-highlight
   lista[itabs].classList.remove("active");
 }

 listaHeader[indicemm].classList.add('p-highlight');  
 listaHeader[indicemm].ariaSelected=true;  
 lista[indicemm].setAttribute('aria-selected','true');
 lista[indicemm].classList.add("active");
 listacontenido[indicemm].setAttribute('style','');
})()

}



const onRowReorder = (event) => {
  if(parseInt(""+mytabindex)===9){
  mytabindex=0;//currentTabIndex.value;
  }else{
    currentTabIndex.value=mytabindex;
  }

  if(filters.value.global.value=="activo"){
  tabs.value[currentTabIndex.value].pages = event.value;
  updateJson('1').then(data=>{
    tabs.value = JSON.parse(data.replace(/\\'/g, "'"));
    //console.log("datos actuakizados");
    changeTabIndexall(mytabindex);

  });

 }
 if(filters.value.global.value!="activo"){
  filters.value.global.value="activo";
 }
};

const selectImage = () => {

  let mediauploader = false;

  if (mediaUploader) {
    mediaUploader.open();
    return;
  }

  mediaUploader = wp.media.frames.file_frame = wp.media({
    title: 'Choose Image',
    button: {
      text: 'Choose Image'
    }, multiple: false
  });

  mediaUploader.on('select', function () {

    let image = mediaUploader.state().get('selection').first().toJSON();
    currentPage.value.image = image.url;
    showImagenLink.html_code = "<img src='" + image.url +
      "' class='img-thumbnails' width='100' style='display: block; margin-left: auto; margin-right: auto;  width: 25%;'>";
    currentPage.value.html_code = "";//showImagenLink.html_code;

  });
  mediaUploader.open();
};

function meduaUpLoaderOPen() {

  let mediauploader = ref(false);
  if (mediaUploader) {
    mediaUploader.open();
    return;
  }


  mediaUploader = wp.media.frames.file_frame = wp.media({
    title: 'Choose Image',
    button: {
      text: 'Choose Image'
    }, multiple: false
  });

  mediaUploader.on('select', function () {

    attachmentoader = mediaUploader.state().get('selection').first().toJSON();
  });


  mediaUploader.open();

}
function getDatosimagen() {

  this.imagenDialog.currentImagen.value = showImagenLink;
}
function getDataLandingPages() {
  getListDataPages();

}

function getListDataPages() {
  fetch("http://localhost/work/wordpress/wp-content/themes/hello-elementor/inc/querys.php")
    .then(respuesta => respuesta.json())
    .then((datosRespuesta) => {

      if (typeof datosRespuesta[0].success === 'undefined') {
        myCurrentData = datosRespuesta;
        myListItem.value = new AutoCompletar();
      }

    })
    .catch(console.log)

}




function verdatos() {
  mylandingpages = myCurrentData;
  currentItemsData.items = myCurrentData;
  var auxitem = [];

  for (var k in mylandingpages) {
    auxitem.push(mylandingpages[k].title);
    console.log(mylandingpages[k].postid + "  " + mylandingpages[k].title);

  }
  myListItem.value.items = auxitem;



}
//loader

function CargarLanding() {
  //getListDataPages();

  var counter = 0;
  var c = 0;
  var i = setInterval(function () {
    document.getElementById("conta").innerHTML = c + "%";
    document.getElementById("barraload").innerHTML = c + "%";
    counter++;
    c++;
    //console.log("cootando " +c);
    if (counter == 10) {
      clearInterval(i);
      waitDialod.value = false;
      //pageDialog.value=true;
      //isEditingPage.value = false;
      //addPage();
      //verdatos();
    }
  }, 10);

}
class AutoCompletar {

  constructor() {
    this.items = [];
    this.results = "";
    this.search = "";
    this.isLoading = false;
    this.isOpen = false;
    this.arrowCounter = -1;
    this.required = false;
    this.default = false;
    this.$el = '#select-landinpage';
    this.opcionvalue = "";
  }
  getOptionValue = () => {
    return this.opcionvalue;
  }
  onChange = () => {
    // Let's warn the parent that a change was made
    this.function("input", this.search);
    // Is the data given by an outside ajax request?
    if (this.isAsync) {
      this.isLoading = true;
    } else {
      // Let's search our flat array
      this.filterResults();
      this.isOpen = true;
    }
  }
  filterResults = () => {
    // first uncapitalize all the things
    this.results = this.items.filter(item => {

      return item.toLowerCase().indexOf(this.search.toLowerCase()) > -1;

    });
    //alert (this.results);
  }
  setResult = (result) => {
    //this.function("input", this.search);   

    this.search = result;
    this.opcionvalue = result;
    alert(this.search);//item seleleccionado  
    //this.function("input", this.search);   
    // console.log("localizado")
    this.isOpen = false;
  }
  onArrowDown = (evt) => {
    if (this.arrowCounter < this.results.length) {
      this.arrowCounter = this.arrowCounter + 1;
    }
  }
  onArrowUp = () => {
    if (this.arrowCounter > 0) {
      this.arrowCounter = this.arrowCounter - 1;
    }
  }
  onEnter = () => {
    this.search = this.results[this.arrowCounter];
    this.isOpen = false;
    this.arrowCounter = -1;
  }
  handleClickOutside = (evt) => {
    if (!this.$el.contains(evt.target)) {
      this.isOpen = false;
      this.arrowCounter = -1;
    }
  }


  function = (val, oldValue) => {
    // actually compare them
    if (val.length !== oldValue.length) {
      this.results = val;
      this.isLoading = false;
    }
  }

  mounted = () => {
    document.addEventListener("click", this.handleClickOutside);
  }
  destroyed = () => {
    document.removeEventListener("click", this.handleClickOutside);
  }




}//fin de mi clase

//termina autocompletar
</script>